<html>
<head>
<title>OgreShaderProgramProcessor.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderProgramProcessor.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderProgramProcessor_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderProgramProcessor_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderProgramProcessor_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderFunctionAtom_8h.html">OgreShaderFunctionAtom.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 <span class="keyword">namespace </span>RTShader {
<a name="l00037"></a>00037 
<a name="l00049"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html">00049</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html" title="A class that provides extra processing services on CPU based programs.">ProgramProcessor</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">// Interface.</span>
<a name="l00053"></a>00053 <span class="keyword">public</span>: 
<a name="l00054"></a>00054 
<a name="l00058"></a>00058     <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html" title="A class that provides extra processing services on CPU based programs.">ProgramProcessor</a>            ();
<a name="l00059"></a>00059 
<a name="l00061"></a>00061     <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html" title="A class that provides extra processing services on CPU based programs.">ProgramProcessor</a>   ();
<a name="l00062"></a>00062 
<a name="l00064"></a>00064     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;       getTargetLanguage   () <span class="keyword">const</span> = 0;
<a name="l00065"></a>00065     
<a name="l00071"></a>00071     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>                preCreateGpuPrograms    (<a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* programSet) = 0;
<a name="l00072"></a>00072 
<a name="l00077"></a>00077     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>                postCreateGpuPrograms   (<a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* programSet) = 0;
<a name="l00078"></a>00078  
<a name="l00079"></a>00079 <span class="comment">// Protected types.</span>
<a name="l00080"></a>00080 <span class="keyword">protected</span>:
<a name="l00081"></a>00081     
<a name="l00082"></a>00082     <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00083"></a>00083     <span class="comment">// Class that holds merge parameter information.</span>
<a name="l00084"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html">00084</a>     <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html">MergeParameter</a> 
<a name="l00085"></a>00085     {
<a name="l00086"></a>00086     <span class="comment">// Interface.</span>
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00089"></a>00089         <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html">MergeParameter</a>();
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00093"></a>00093         <span class="keywordtype">void</span>            clear                       ();
<a name="l00094"></a>00094         
<a name="l00096"></a>00096         <span class="keywordtype">void</span>            addSourceParameter          (<a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> srcParam, <span class="keywordtype">int</span> mask);
<a name="l00097"></a>00097 
<a name="l00099"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#a50184aa6145aacb52c3bb0646bf99616">00099</a>         <span class="keywordtype">size_t</span>          <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#a50184aa6145aacb52c3bb0646bf99616" title="Return the source parameter count.">getSourceParameterCount</a>     ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSrcParameterCount; }
<a name="l00100"></a>00100 
<a name="l00102"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#adff8f04ad3d1d7e9b0df387d51acca02">00102</a>         <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>    <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#adff8f04ad3d1d7e9b0df387d51acca02" title="Return source parameter by index.">getSourceParameter</a>          (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) { <span class="keywordflow">return</span> mSrcParameter[index]; }
<a name="l00103"></a>00103 
<a name="l00105"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#ae57b334bf47ef57b7cf4efc1ae6a7fc1">00105</a>         <span class="keywordtype">int</span>             <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#ae57b334bf47ef57b7cf4efc1ae6a7fc1" title="Return source parameter mask by index.">getSourceParameterMask</a>      (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSrcParameterMask[index]; }
<a name="l00106"></a>00106 
<a name="l00108"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#ab0f42e37e7832ec1c7a8cf9fb144d2ed">00108</a>         <span class="keywordtype">int</span>             <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#ab0f42e37e7832ec1c7a8cf9fb144d2ed" title="Return destination parameter mask by index.">getDestinationParameterMask</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDstParameterMask[index]; }
<a name="l00109"></a>00109 
<a name="l00111"></a>00111         <span class="keywordtype">int</span>             getUsedFloatCount           ();
<a name="l00112"></a>00112         
<a name="l00114"></a>00114         <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>    getDestinationParameter     (<span class="keywordtype">int</span> usage, <span class="keywordtype">int</span> index);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116     <span class="keyword">protected</span>:
<a name="l00117"></a>00117     
<a name="l00119"></a>00119         <span class="keywordtype">void</span>            createDestinationParameter  (<span class="keywordtype">int</span> usage, <span class="keywordtype">int</span> index);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="keyword">protected</span>:
<a name="l00123"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#ac90ba3de55672229fe80e9724e6de4b0">00123</a>         <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>    <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#ac90ba3de55672229fe80e9724e6de4b0">mDstParameter</a>;          <span class="comment">// Destination merged parameter.</span>
<a name="l00124"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#a80410761869471108fb0e4b73b4f106b">00124</a>         <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>    mSrcParameter[4];       <span class="comment">// Source parameters - 4 source at max 1,1,1,1 -&gt; 4.</span>
<a name="l00125"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#ac46769ec8723babd331b00b0d032b903">00125</a>         <span class="keywordtype">int</span>             mSrcParameterMask[4];   <span class="comment">// Source parameters mask. OPM_ALL means all fields used, otherwise it is split source parameter.</span>
<a name="l00126"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#a105644410a8a59b0146ccffdf531adfd">00126</a>         <span class="keywordtype">int</span>             mDstParameterMask[4];   <span class="comment">// Destination parameters mask. OPM_ALL means all fields used, otherwise it is split source parameter.</span>
<a name="l00127"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#afe2a4539206198072d74a3f43d62ef56">00127</a>         <span class="keywordtype">size_t</span>          <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#afe2a4539206198072d74a3f43d62ef56">mSrcParameterCount</a>;     <span class="comment">// The actual source parameters count.</span>
<a name="l00128"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#ab162cd2e87c41aa7f73f1a2cea3e3039">00128</a>         <span class="keywordtype">size_t</span>          <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html#ab162cd2e87c41aa7f73f1a2cea3e3039">mUsedFloatCount</a>;        <span class="comment">// The number of used floats.</span>
<a name="l00129"></a>00129     };
<a name="l00130"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">00130</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;MergeParameter&gt;::type</a>    <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a>;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132     
<a name="l00133"></a>00133     <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00134"></a>00134     <span class="comment">// A struct that defines merge parameters combination.</span>
<a name="l00135"></a><a class="code" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html">00135</a>     <span class="keyword">struct </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html">MergeCombination</a>
<a name="l00136"></a>00136     {       
<a name="l00137"></a><a class="code" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html#aabf439632c0a3ab56061634b0c42c4bb">00137</a>         <span class="keywordtype">size_t</span>          srcParamterTypeCount[4];    <span class="comment">// The count of each source type. I.E (1 FLOAT1, 0 FLOAT2, 1 FLOAT3, 0 FLOAT4).</span>
<a name="l00138"></a><a class="code" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html#a8dffc06c2e9883767c242b11e0452bfa">00138</a>         <span class="keywordtype">int</span>             srcParameterMask[4];        <span class="comment">// Source parameters mask. OPM_ALL means all fields used, otherwise it is split source parameter.</span>
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html#a7f88e55801edfd6436a69f75ef6b333e">00140</a>         <a class="code" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html">MergeCombination</a>(
<a name="l00141"></a>00141             <span class="keywordtype">int</span> float1Count, <span class="keywordtype">int</span> float1Mask,
<a name="l00142"></a>00142             <span class="keywordtype">int</span> float2Count, <span class="keywordtype">int</span> float2Mask,
<a name="l00143"></a>00143             <span class="keywordtype">int</span> float3Count, <span class="keywordtype">int</span> float3Mask,
<a name="l00144"></a>00144             <span class="keywordtype">int</span> float4Count, <span class="keywordtype">int</span> float4Mask)
<a name="l00145"></a>00145         {
<a name="l00146"></a>00146             srcParamterTypeCount[0] = float1Count;
<a name="l00147"></a>00147             srcParamterTypeCount[1] = float2Count;
<a name="l00148"></a>00148             srcParamterTypeCount[2] = float3Count;
<a name="l00149"></a>00149             srcParamterTypeCount[3] = float4Count;
<a name="l00150"></a>00150             srcParameterMask[0]     = float1Mask;
<a name="l00151"></a>00151             srcParameterMask[1]     = float2Mask;
<a name="l00152"></a>00152             srcParameterMask[2]     = float3Mask;
<a name="l00153"></a>00153             srcParameterMask[3]     = float4Mask;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155         }
<a name="l00156"></a>00156     };
<a name="l00157"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a3c0d805a8cdf9a02b95bcfeb80dc331c">00157</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;MergeCombination&gt;::type</a>  <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a3c0d805a8cdf9a02b95bcfeb80dc331c">MergeCombinationList</a>;
<a name="l00158"></a>00158 
<a name="l00159"></a>00159     <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00160"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a03d0a099a4a495164fe4603d814d18b9">00160</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;Operand*&gt;::type</a>                      <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a03d0a099a4a495164fe4603d814d18b9">OperandPtrVector</a>;
<a name="l00161"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">00161</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;Parameter*, OperandPtrVector&gt;::type</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a>;
<a name="l00162"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">00162</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;Parameter*, ParameterPtr&gt;::type</a>         <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a>;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="keyword">protected</span>:
<a name="l00165"></a>00165 
<a name="l00167"></a>00167     <span class="keywordtype">void</span>            buildMergeCombinations          ();
<a name="l00168"></a>00168 
<a name="l00174"></a>00174     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>    compactVsOutputs                (<a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* vsMain, <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* fsMain);
<a name="l00175"></a>00175 
<a name="l00181"></a>00181     <span class="keywordtype">void</span>            countVsTexcoordOutputs          (<a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* vsMain, <span class="keywordtype">int</span>&amp; outTexCoordSlots, <span class="keywordtype">int</span>&amp; outTexCoordFloats);
<a name="l00182"></a>00182 
<a name="l00187"></a>00187     <span class="keywordtype">void</span>            buildTexcoordTable              (<span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp; paramList, <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> outParamsTable[4]);
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00194"></a>00194     <span class="keywordtype">void</span>            mergeParameters                 (<a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> paramsTable[4], <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a>&amp; mergedParams, <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp; splitParams);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00201"></a>00201     <span class="keywordtype">void</span>            mergeParametersByPredefinedCombinations(<a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> paramsTable[4], <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a>&amp; mergedParams);
<a name="l00202"></a>00202 
<a name="l00208"></a>00208     <span class="keywordtype">bool</span>            mergeParametersByCombination            (<span class="keyword">const</span> <a class="code" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html">MergeCombination</a>&amp; combination, <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> paramsTable[4], 
<a name="l00209"></a>00209                                                                  <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html">MergeParameter</a>* mergedParameter);
<a name="l00210"></a>00210 
<a name="l00216"></a>00216     <span class="keywordtype">void</span>            mergeParametersReminders                (<a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> paramsTable[4], <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a>&amp; mergedParams, <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp; splitParams);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00220"></a>00220     <span class="keywordtype">void</span>            generateLocalSplitParameters                (<a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* func, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> progType, <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a>&amp; mergedParams, <a class="code" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&amp; splitParams, <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a>&amp; localParamsMap);
<a name="l00221"></a>00221     
<a name="l00224"></a>00224     <span class="keywordtype">void</span>            rebuildParameterList                (<a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* func, <span class="keywordtype">int</span> paramsUsage, <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a>&amp; mergedParams);
<a name="l00225"></a>00225 
<a name="l00227"></a>00227     <span class="keywordtype">void</span>            rebuildFunctionInvocations          (<a class="code" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a>&amp; funcAtomList, <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a>&amp; mergedParams, <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a>&amp; localParamsMap);
<a name="l00228"></a>00228 
<a name="l00230"></a>00230     <span class="keywordtype">void</span>            buildParameterReferenceMap          (<a class="code" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a>&amp; funcAtomList, <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a>&amp; paramsRefMap);
<a name="l00231"></a>00231 
<a name="l00233"></a>00233     <span class="keywordtype">void</span>            replaceParametersReferences         (<a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a>&amp; mergedParams, <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a>&amp; paramsRefMap);
<a name="l00234"></a>00234 
<a name="l00236"></a>00236     <span class="keywordtype">void</span>            replaceSplitParametersReferences    (<a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a>&amp; localParamsMap, <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a>&amp; paramsRefMap);
<a name="l00237"></a>00237 
<a name="l00239"></a>00239     <span class="keyword">static</span> <span class="keywordtype">int</span>      getParameterFloatCount              (<a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type);     
<a name="l00240"></a>00240 
<a name="l00242"></a>00242     <span class="keyword">static</span> <span class="keywordtype">int</span>      getParameterMaskByType              (<a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a> type);
<a name="l00243"></a>00243     
<a name="l00245"></a>00245     <span class="keyword">static</span> <span class="keywordtype">int</span>      getParameterMaskByFloatCount        (<span class="keywordtype">int</span> floatCount);
<a name="l00246"></a>00246     
<a name="l00248"></a>00248     <span class="keywordtype">void</span>            bindAutoParameters                  (<a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* pCpuProgram, <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> pGpuProgram);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 <span class="keyword">protected</span>:
<a name="l00251"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a060e0a7726b01ff4bc1c83fc064ba406">00251</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a3c0d805a8cdf9a02b95bcfeb80dc331c">MergeCombinationList</a>    <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a060e0a7726b01ff4bc1c83fc064ba406">mParamMergeCombinations</a>;        <span class="comment">// Merging combinations defs.</span>
<a name="l00252"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#af100cb3dc3fdd00a44e85922df61863c">00252</a>     <span class="keywordtype">int</span>                     <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#af100cb3dc3fdd00a44e85922df61863c">mMaxTexCoordSlots</a>;              <span class="comment">// Maximum texcoord slots.</span>
<a name="l00253"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ada7e3fd71cc0ce8aee28b5fe0b90d13e">00253</a>     <span class="keywordtype">int</span>                     <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ada7e3fd71cc0ce8aee28b5fe0b90d13e">mMaxTexCoordFloats</a>;             <span class="comment">// Maximum texcoord floats count.</span>
<a name="l00254"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ad88eb5eeb95f7cbe526b124e793fd6ae">00254</a>     std::map&lt;Function *, String *&gt;  <a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ad88eb5eeb95f7cbe526b124e793fd6ae">mFunctionMap</a>;           <span class="comment">// Map between function signatures and source code</span>
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 };
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="preprocessor">#endif</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
